package actionScripts.utils
{
	import flash.desktop.NativeProcess;
	import flash.desktop.NativeProcessStartupInfo;
	import flash.events.DataEvent;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.NativeProcessExitEvent;
	import flash.events.ProgressEvent;
	import flash.events.SecurityErrorEvent;
	import flash.filesystem.File;
	import flash.net.XMLSocket;
	import flash.utils.IDataInput;
	
	import mx.events.CollectionEvent;
	
	import actionScripts.events.FileChangeEvent;
	import actionScripts.events.GlobalEventDispatcher;
	import actionScripts.events.ShowDropDownForTypeAhead;
	import actionScripts.events.TypeAheadEvent;
	import actionScripts.locator.IDEModel;
	import actionScripts.plugin.actionscript.as3project.vo.AS3ProjectVO;
	import actionScripts.plugin.console.ConsoleOutputter;
	import actionScripts.plugin.help.HelpPlugin;
	import actionScripts.ui.editor.BasicTextEditor;
	import actionScripts.ui.menu.MenuPlugin;
	import actionScripts.valueObjects.ProjectReferenceVO;
	import actionScripts.valueObjects.Settings;
	import actionScripts.vo.TypeAheadVO;
	
	import no.doomsday.console.ConsoleUtil;
	
	public class TypeAheadProcess
	{
		private var cmdFile: File;
		private var shellInfo: NativeProcessStartupInfo;
		private var nativeProcess: NativeProcess;
		private var checkingQueues: Array; 
		private var xmlSocket :XMLSocket;
		private var flag:Boolean = false;
		private var model:IDEModel = IDEModel.getInstance();
		//private var setFlexJSSDKPopup:SetFlexJSSDKMessagePopup;
		private var javaPath:String;
		private var dispatcher:GlobalEventDispatcher = GlobalEventDispatcher.getInstance();
		
		public function TypeAheadProcess(path:String)
		{
			if (Settings.os == "win")
			{
				cmdFile = new File("c:\\Windows\\System32\\cmd.exe");
			}
			else 
			{
				cmdFile = File.documentsDirectory.resolvePath("/usr/bin/java");
			}
			this.javaPath = path;
			model.userSavedSDKs.addEventListener(CollectionEvent.COLLECTION_CHANGE,collectionChangedHandler);
			GlobalEventDispatcher.getInstance().addEventListener(TypeAheadEvent.EVENT_TYPEAHEAD,didChangeCall);
			GlobalEventDispatcher.getInstance().addEventListener(FileChangeEvent.EVENT_FILECHANGE,didOpenCall);
			GlobalEventDispatcher.getInstance().addEventListener(MenuPlugin.MENU_QUIT_EVENT, shutdownHandler);
			//connectToJava();
			startNativeProcess();
		}
		
		private function startNativeProcess():void
		{
			var processArgs:Vector.<String> = new Vector.<String>;
			shellInfo = new NativeProcessStartupInfo();
			var jarFile:File = File.applicationDirectory.resolvePath("elements/codecompletion.jar");
			if (Settings.os == "win")
			{
				processArgs.push("/C");
				processArgs.push("java");
				processArgs.push("-jar");
				processArgs.push(jarFile.nativePath);
			}
			else
			{
				processArgs.push("-jar");
				processArgs.push(jarFile.nativePath);
			}
			var javafile:File = new File(this.javaPath);
			shellInfo.workingDirectory =javafile;
			shellInfo.arguments = processArgs;
			shellInfo.executable = cmdFile;
			initShell();
		}
		
		private function initShell():void 
		{
			if (nativeProcess) nativeProcess.exit();
			else startShell();
		}
		
		private function startShell():void 
		{
			nativeProcess = new NativeProcess();
			nativeProcess.addEventListener(ProgressEvent.STANDARD_OUTPUT_DATA, shellData);
			nativeProcess.addEventListener(ProgressEvent.STANDARD_ERROR_DATA, shellError);
			nativeProcess.addEventListener(NativeProcessExitEvent.EXIT, shellExit);
			nativeProcess.start(shellInfo);
		}
		
		private function shellData(e:ProgressEvent):void 
		{
			var output:IDataInput = nativeProcess.standardOutput;
			parseData(output.readUTFBytes(output.bytesAvailable));
		}
		
		private function shellError(e:ProgressEvent):void 
		{
			
			var output:IDataInput = nativeProcess.standardError;
			var data:String = output.readUTFBytes(output.bytesAvailable);
			ConsoleUtil.print("shellError " + data + ".");
			ConsoleOutputter.formatOutput(HtmlFormatter.sprintfa(data, null), 'weak');
			var match:Array;
			//A new filter added here which will detect command for FDB exit
			match = data.match(/.*\ onConnected */);
			if(match)
			{
				trace(data);
				parseData(output.readUTFBytes(output.bytesAvailable));
			}
			else
			{
				trace(data);
				//Alert.show("jar connection "+data);
			}
			
		}
		
		private function shellExit(e:NativeProcessExitEvent):void 
		{
			if(xmlSocket)shutdownHandler(null);
			nativeProcess.removeEventListener(ProgressEvent.STANDARD_OUTPUT_DATA, shellData);
			nativeProcess.removeEventListener(ProgressEvent.STANDARD_ERROR_DATA, shellError);
			nativeProcess.removeEventListener(NativeProcessExitEvent.EXIT, shellExit);
			nativeProcess.exit();
			nativeProcess = null;
		}
		
		private function parseData(data:String):void
		{
			//Alert.show(data+" Parse Data " + flag);
			if(!flag)connectToJava();
		}
		
		protected function connectToJava():void
		{
			// TODO Auto-generated method stub
			//Alert.show("connect to java "+xmlSocket);
			if(!xmlSocket)
			{
				//Alert.show("XML Socket Start");
				xmlSocket = new XMLSocket();
				xmlSocket.connect("127.0.0.1", 58080);
				
				xmlSocket.addEventListener(DataEvent.DATA, onIncomingData);
				xmlSocket.addEventListener(IOErrorEvent.IO_ERROR,onSocketIOError);
				xmlSocket.addEventListener(SecurityErrorEvent.SECURITY_ERROR,onSocketSecurityErr);
				xmlSocket.addEventListener(Event.CONNECT,onConnect);
				xmlSocket.addEventListener(Event.CLOSE,closeHandler);
				//collectionChangedHandler(null);//Call collection change handle for sending flexjs sdk to java when java server start
				flag = true;
			}
		}
		
		private function closeHandler(evt:Event):void{
			if(xmlSocket){
				xmlSocket.close();
				xmlSocket = null;
			}
			
		}
		
		private function onConnect(event:Event):void{
			collectionChangedHandler(null);//Call collection change handle for sending flexjs sdk to java when java server start
		}
		 private function onSocketIOError(event:IOErrorEvent):void {
			 ConsoleUtil.print("ioError " + event.text + ".");
			 ConsoleOutputter.formatOutput(HtmlFormatter.sprintfa("ioError "+event, null), 'weak');
			}
		
		private function onSocketSecurityErr(event:SecurityErrorEvent):void {
			ConsoleUtil.print("securityError " + event.text + ".");
			ConsoleOutputter.formatOutput(HtmlFormatter.sprintfa("securityError "+event, null), 'weak');
		}
		
		//Read Incoming data
		private function onIncomingData(event:DataEvent):void
		{
				var data:String = event.data;
				trace(data);
				//Alert.show("Data"+data);
				//Alert.show("incomeing data "+data);
				var object:Object = JSON.parse(data);
				var resultArr:Array = (object.result.items) as Array;
				if(resultArr){
				var typeAheadArr:Array = new Array();
				for(var i:int=0;i<resultArr.length;i++)
				{
					var typeAheadVO:TypeAheadVO = new TypeAheadVO();
					typeAheadVO.label = resultArr[i].label;
					typeAheadVO.detail  = resultArr[i].detail;
					typeAheadVO.kind = resultArr[i].kind;
					typeAheadArr.push(typeAheadVO);
				}
				typeAheadArr.sortOn("label",Array.CASEINSENSITIVE);
				GlobalEventDispatcher.getInstance().dispatchEvent(new ShowDropDownForTypeAhead(ShowDropDownForTypeAhead.EVENT_SHOWDROPDOWN,typeAheadArr));
				}
			}
		
		//For shutdown java socket
		public function shutdownHandler(event:Event):void{
			if(xmlSocket)xmlSocket.send("SHUTDOWN");
			xmlSocket = null;
		}
		
		//Call Didopen from Java
		private function didOpenCall(evt:FileChangeEvent):void{
			if(xmlSocket)
			{
				DidChangeConfigurationParams();
				var obj:Object = new Object();
				obj.jsonrpc = "2.0";
				obj.id=1;
				obj.method = "textDocument/didOpen";
				var textDocument:Object = new Object();
				textDocument.uri = evt.filePath;
				textDocument.languageId = "1";
				textDocument.version = 1;
				textDocument.text = "";
				var params:Object = new Object();
				params.textDocument = textDocument;
				obj.params = params;
				var jsonstr:String = JSON.stringify(obj);
				xmlSocket.send(jsonstr);
				
				//Alert.show(jsonstr+"didopen");
			}
		}
		
		//Listen events for userSavedSDKs collection changed
		private function collectionChangedHandler(evt:CollectionEvent):void{
			if(xmlSocket)
			{
				
				var hasFlexJS:Boolean = checkFlexJSSDK();
				if(!hasFlexJS)
				{
					dispatcher.dispatchEvent(new Event(HelpPlugin.EVENT_TYPEAHEAD_REQUIRES_SDK));
					
					//Open an Alert for message
					/*if(!setFlexJSSDKPopup)
					{
						setFlexJSSDKPopup = PopUpManager.createPopUp(FlexGlobals.topLevelApplication as DisplayObject, SetFlexJSSDKMessagePopup ,false) as SetFlexJSSDKMessagePopup;
						setFlexJSSDKPopup.addEventListener(SetFlexJSSDKMessagePopup.SET_SDK, onFlexSDKUpdated);
						setFlexJSSDKPopup.addEventListener(SetFlexJSSDKMessagePopup.CONTINUE, onFlexSDKContinue);
						setFlexJSSDKPopup.addEventListener(SetFlexJSSDKMessagePopup.CANCELLED, onFlexSDKContinue);
						PopUpManager.centerPopUp(setFlexJSSDKPopup);
					}
					else
					{
						PopUpManager.centerPopUp(setFlexJSSDKPopup);
					}*/
				}
			}
		}
		
		private function checkFlexJSSDK():Boolean
		{
			var hasFlex:Boolean = false;
			if(xmlSocket)
			{
				var path:String;
				for each (var i:ProjectReferenceVO in model.userSavedSDKs)
				{
					if (i.name.indexOf("Apache Flex (FlexJS) 0.7.0")!=-1)
					{
						trace(i.path);
						path = i.path;
						hasFlex = true;
						break
					}
				}
				if(!hasFlex)
				{
					path = "";
				}
				var obj:Object = new Object();
				obj.jsonrpc = "2.0";
				obj.id=1;
				obj.method = "textDocument/flexJSPath";
				var params:Object = new Object();
				params.flexJSPath = path;
				obj.params = params;
				var jsonstr:String = JSON.stringify(obj);
				xmlSocket.send(jsonstr);
		
			}
			return hasFlex;
		}
		
		private function onFlexSDKUpdated(evt:Event):void{
			//setFlexJSSDKPopup = null;
		}
		
		private function onFlexSDKContinue(evt:Event):void{
			//PopUpManager.removePopUp(setFlexJSSDKPopup);
			//setFlexJSSDKPopup = null;
		}
		
		private function DidChangeConfigurationParams():void{
			var obj:Object = new Object();
			obj.jsonrpc = "2.0";
			obj.id=1;
			obj.method = "workspace/didChangeConfiguration";
			var pvo:AS3ProjectVO = model.activeProject as AS3ProjectVO;
			if(pvo)
			{
				if(xmlSocket)
				{
				var DidChangeConfigurationParams:Object = new Object();
				DidChangeConfigurationParams.uri = pvo.targets[0].fileBridge.nativePath;
				var buildArgs:String = pvo.buildOptions.getArguments();
				var dbg:String;
				if (buildArgs.indexOf(" -debug=") > -1) dbg = "false";
				DidChangeConfigurationParams.debug = dbg;
				DidChangeConfigurationParams.config = pvo.air?"air":"flex";
				var params:Object = new Object();
				params.DidChangeConfigurationParams = DidChangeConfigurationParams;
				obj.params = params;
				var jsonstr:String = JSON.stringify(obj);
				xmlSocket.send(jsonstr); 
				//Alert.show(jsonstr+"didchangeconfi");
				}
			}
		}
		
		private function didChangeCall(evt:TypeAheadEvent):void{
			if(xmlSocket)
			{	
				var obj:Object = new Object();
				obj.jsonrpc = "2.0";
				obj.id=1;
				obj.method = "textDocument/didChange";
				
				var textDocument:Object = new Object();
				textDocument.version = 1;
				textDocument.uri = (model.activeEditor as BasicTextEditor).currentFile.fileBridge.url;
				
				var range:Object = new Object();
				var startposition:Object = new Object();
				startposition.line = evt.startLineNumber;
				startposition.character = evt.startLinePos;
				range.start = startposition;
				
				var endposition:Object = new Object();
				endposition.line =evt.endLineNumber;
				endposition.character = evt.endLinePos;
				range.end = endposition;
				
				var contentChangesArr:Array = new Array();
				var contentChanges:Object = new Object();
				contentChanges.range = null;//range;
				contentChanges.rangeLength = 0;//evt.textlen;
				contentChanges.text = evt.newText;
				
				var DidChangeTextDocumentParams:Object = new Object();
				DidChangeTextDocumentParams.textDocument = textDocument;
				DidChangeTextDocumentParams.contentChanges = contentChanges;
				
				var params:Object = new Object();
				params.DidChangeTextDocumentParams = DidChangeTextDocumentParams;
				obj.params = params;
				var jsonstr:String = JSON.stringify(obj);
				xmlSocket.send(jsonstr);
				completion(evt);
				//Alert.show(jsonstr+"didchange");
			}
		}
		
		private function completion(evt:TypeAheadEvent):void{
			if(xmlSocket)
			{
				var obj:Object = new Object();
				obj.jsonrpc = "2.0";
				obj.id=1;
				obj.method = "textDocument/completion";
				
				var textDocument:Object = new Object();
				textDocument.uri = (model.activeEditor as BasicTextEditor).currentFile.fileBridge.url;
				
				var position:Object = new Object();
				position.line = evt.endLineNumber;
				position.character = evt.endLinePos;
				
				var TextDocumentPositionParams:Object = new Object();
				TextDocumentPositionParams.textDocument = textDocument;
				TextDocumentPositionParams.position = position;
				
				var params:Object = new Object();
				params.TextDocumentPositionParams = TextDocumentPositionParams;
				obj.params = params;
				
				var jsonstr:String = JSON.stringify(obj);
				xmlSocket.send(jsonstr);
				//Alert.show(jsonstr+"completion");
			}
		}
	}
	
}