/**
 * Copyright (c) 2016 TypeFox GmbH (http://www.typefox.io) and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 */
package io.typefox.lsapi;

import io.typefox.lsapi.ResponseErrorCode;
import javax.annotation.Nullable;

@SuppressWarnings("all")
public interface ResponseError {
  /**
   * A number indicating the error type that occured.
   */
  public abstract ResponseErrorCode getCode();
  
  /**
   * A string providing a short decription of the error.
   */
  public abstract String getMessage();
  
  /**
   * A Primitive or Structured value that contains additional information about the error. Can be omitted.
   */
  @Nullable
  public abstract Object getData();
}
