/**
 * Copyright (c) 2016 TypeFox GmbH (http://www.typefox.io) and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 */
package io.typefox.lsapi;

import io.typefox.lsapi.MessageActionItem;
import io.typefox.lsapi.MessageParams;
import java.util.List;
import javax.annotation.Nullable;

/**
 * The show message request is sent from a server to a client to ask the client to display a particular message in the
 * user interface. In addition to the show message notification the request allows to pass actions and to wait for an
 * answer from the client.
 */
@SuppressWarnings("all")
public interface ShowMessageRequestParams extends MessageParams {
  /**
   * The message action items to present.
   */
  @Nullable
  public abstract List<? extends MessageActionItem> getActions();
}
