/**
 * Copyright (c) 2016 TypeFox GmbH (http://www.typefox.io) and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 */
package io.typefox.lsapi;

import io.typefox.lsapi.Location;
import io.typefox.lsapi.SymbolKind;
import javax.annotation.Nullable;

/**
 * Represents information about programming constructs like variables, classes, interfaces etc.
 */
@SuppressWarnings("all")
public interface SymbolInformation {
  /**
   * The name of this symbol.
   */
  public abstract String getName();
  
  /**
   * The kind of this symbol.
   */
  public abstract SymbolKind getKind();
  
  /**
   * The location of this symbol.
   */
  public abstract Location getLocation();
  
  /**
   * The name of the symbol containing this symbol.
   */
  @Nullable
  public abstract String getContainerName();
}
