/**
 * Copyright (c) 2016 TypeFox GmbH (http://www.typefox.io) and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 */
package io.typefox.lsapi.builders;

import io.typefox.lsapi.CancelParams;
import io.typefox.lsapi.builders.IBuilder;
import io.typefox.lsapi.impl.CancelParamsImpl;
import org.eclipse.xtext.xbase.lib.Procedures.Procedure1;

/**
 * Builder for instances of {@link CancelParams}.
 */
@SuppressWarnings("all")
public class CancelParamsBuilder implements IBuilder<CancelParams> {
  public CancelParamsBuilder() {
    
  }
  
  public CancelParamsBuilder(final Procedure1<CancelParamsBuilder> initializer) {
    initializer.apply(this);
  }
  
  /**
   * The request id to cancel.
   */
  private String id;
  
  public CancelParamsBuilder id(final String id) {
    this.id = id;
    return this;
  }
  
  /**
   * Build the configured instance.
   */
  @Override
  public CancelParams build() {
    CancelParamsImpl result = new CancelParamsImpl();
    internalBuild(result);
    return result;
  }
  
  protected void internalBuild(final CancelParamsImpl result) {
    result.setId(this.id);
  }
}
