/**
 * Copyright (c) 2016 TypeFox GmbH (http://www.typefox.io) and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 */
package io.typefox.lsapi.builders;

import io.typefox.lsapi.DidChangeConfigurationParams;
import io.typefox.lsapi.builders.IBuilder;
import io.typefox.lsapi.impl.DidChangeConfigurationParamsImpl;
import org.eclipse.xtext.xbase.lib.Procedures.Procedure1;

/**
 * Builder for instances of {@link DidChangeConfigurationParams}.
 */
@SuppressWarnings("all")
public class DidChangeConfigurationParamsBuilder implements IBuilder<DidChangeConfigurationParams> {
  public DidChangeConfigurationParamsBuilder() {
    
  }
  
  public DidChangeConfigurationParamsBuilder(final Procedure1<DidChangeConfigurationParamsBuilder> initializer) {
    initializer.apply(this);
  }
  
  private Object settings;
  
  public DidChangeConfigurationParamsBuilder settings(final Object settings) {
    this.settings = settings;
    return this;
  }
  
  /**
   * Build the configured instance.
   */
  @Override
  public DidChangeConfigurationParams build() {
    DidChangeConfigurationParamsImpl result = new DidChangeConfigurationParamsImpl();
    internalBuild(result);
    return result;
  }
  
  protected void internalBuild(final DidChangeConfigurationParamsImpl result) {
    result.setSettings(this.settings);
  }
}
